\ ef16.txt for P8, 27sep99cht, interpreter working
\       DUMP, SEE, VARIABLE, : all crash the system
\       improve error abort and DUMP
\
\ eForth.seq, adapted from Bill Muench's aFIG.b, 27feb96cht
\ V2.06, slow down I/O for stability of RS232, 11/nov95cht
\ V2.07, merge rectangle routine in hline27, 24nov95cht
\ V20.8, add RECTANGLE to ok28c.seq, add space to 'redef ',
\        use 82C51 for serial communication. 18mar96cht

CRR .( System variables ) CRR

\ 810 ORG

VARIABLE tmp 0 #,         COMPILE-ONLY \ scratch
VARIABLE SPAN 0 #,        \ #chars input by EXPECT
VARIABLE >IN  0 #,        \ input buffer offset
VARIABLE #TIB 0 #,        \ #chars in the input buffer
         endRAM 50 forth- #,   \ TIB
VARIABLE CSP  0 #,        \ save stack pointers
VARIABLE 'EVAL 7D5 #,           \ interpret/compile vector
VARIABLE 'NUMBER 500 #,         \ numeric input vector

CRR

VARIABLE HLD 0 #,        \ ptr to converted # string
VARIABLE HANDLER 0 #,    \ error frame pointer
VARIABLE CONTEXT 1E7 #,    \ first search vocabulary
   0 #, 0 #,
VARIABLE CURRENT 1E7 #,    \ definitions vocabulary
   0 #,
VARIABLE CP C43 #,         \ dictionary code pointer
VARIABLE LAST C2E #,       \ ptr to last name compiled

CRR

VARIABLE 'TAP 74F #,     \ input case vector
VARIABLE 'ECHO EMIT    \ input echo vector
VARIABLE 'PROMPT 816 #,  \ operator prompt vector
VARIABLE BASE 0A #,     \ number base
VARIABLE NULL$ 0 #,     \ abort
VARIABLE VOCAB C2E #,     \ FORTH

CRR .( Common functions ) CRR

:: FORTH ( -- ) VOCAB CONTEXT ! ;;
:: ?DUP ( w -- w w | 0 ) DUP IF DUP THEN ;;
:: ROT ( w1 w2 w3 -- w2 w3 w1 ) >R SWAP R> SWAP ;;
:: 2DROP ( w w  -- ) DROP DROP ;;
:: 2DUP ( w1 w2 -- w1 w2 w1 w2 ) OVER OVER ;;
:: NOT ( w -- w ) -1 LIT XOR ;;

CRR

::  NEGATE ( n -- -n ) NOT 1 LIT + ;;
:: DNEGATE ( d -- -d ) NOT >R NOT 1 LIT UM+ R> + ;;
:: ABS ( n -- +n ) DUP 0< IF NEGATE THEN ;;

CRR .( Comparison ) CRR

:: = ( w w -- t ) XOR IF 0 LIT EXIT THEN -1 LIT ;;
:: U< ( u u -- t ) 2DUP XOR 0< IF SWAP DROP 0< EXIT THEN - 0< ;;
::  < ( n n -- t ) 2DUP XOR 0< IF      DROP 0< EXIT THEN - 0< ;;
:: MAX ( n n -- n ) 2DUP      < IF SWAP THEN DROP ;;
:: MIN ( n n -- n ) 2DUP SWAP < IF SWAP THEN DROP ;;
:: WITHIN ( u ul uh -- t ) \ ul <= u < uh
  OVER - >R - R> U< ;;

CRR .( Divide ) CRR

:: UM/MOD ( ud u -- ur uq )
  2DUP U<
  IF NEGATE  $0F LIT
    FOR >R DUP UM+ >R >R DUP UM+ R> + DUP
        R> R@ SWAP >R UM+  R> OR
      IF >R DROP 1 LIT + R> ELSE DROP THEN R>
    NEXT DROP SWAP EXIT
  THEN DROP 2DROP  -1 LIT DUP ;;
:: M/MOD ( d n -- r q ) \ floored
  DUP 0<  DUP >R
  IF NEGATE >R DNEGATE R>
  THEN >R DUP 0< IF R@ + THEN R> UM/MOD R>
  IF SWAP NEGATE SWAP THEN ;;
:: /MOD ( n n -- r q ) OVER 0< SWAP M/MOD ;;
:: MOD ( n n -- r ) /MOD DROP ;;
:: / ( n n -- q ) /MOD SWAP DROP ;;

CRR .( Multiply ) CRR

:: UM* ( u u -- ud )
  0 LIT SWAP ( u1 0 u2 ) $0F LIT ( 19 decimal )
  FOR DUP UM+ >R >R DUP UM+ R> + R>
    IF >R OVER UM+ R> + THEN
  NEXT ROT DROP ;;
:: * ( n n -- n ) UM* DROP ;;
:: M* ( n n -- d )
  2DUP XOR 0< >R  ABS SWAP ABS UM*  R> IF DNEGATE THEN ;;
:: */MOD ( n n n -- r q ) >R M* R> M/MOD ;;
:: */ ( n n n -- q ) */MOD SWAP DROP ;;

CRR .( Bits & Bytes ) CRR

:: 1- ( a -- a ) -1 LIT + ;;
:: 1+ ( a -- a ) 1 LIT + ;;
:: BL ( -- 32 ) 20 LIT ;;
:: >CHAR ( c -- c )
  $7F LIT AND DUP $7F LIT BL WITHIN
  IF DROP ( CHAR _ ) $5F LIT THEN ;;

CRR .( Memory access ) CRR

:: +! ( n a -- ) SWAP OVER @ + SWAP ! ;;
:: 2! ( d a -- ) SWAP OVER ! 1+ ! ;;
:: 2@ ( a -- d ) DUP 1+ @ SWAP @ ;;
:: COUNT ( b -- b +n ) DUP 1 LIT + SWAP C@ ;;
:: HERE ( -- a ) CP @ ;;
:: PAD ( -- a ) HERE 50 LIT  + ;;
:: TIB ( -- a ) #TIB 1+ @ ;;
CRR
:: @EXECUTE ( a -- ) @ ?DUP IF EXECUTE THEN ;;
:: CMOVE ( b b u -- )
  FOR AFT >R DUP C@ R@ C! 1+ R> 1+ THEN NEXT 2DROP ;;
:: FILL ( b u c -- )
  SWAP FOR SWAP AFT 2DUP C! 1+ THEN NEXT 2DROP ;;
:: PACK$ ( b u a -- a ) \ null fill
  DUP >R 2DUP C!  1+ SWAP CMOVE  R> ;;

CRR .( Numeric Output ) CRR \ single precision

:: DIGIT ( u -- c ) 9 LIT OVER < 7 LIT AND +
  ( CHAR 0 ) 30 LIT + ;;
:: EXTRACT ( n base -- n c ) 0 LIT SWAP UM/MOD SWAP DIGIT ;;
:: <# ( -- ) PAD HLD ! ;;
:: HOLD ( c -- ) HLD @ 1- DUP HLD ! C! ;;
:: # ( u -- u ) BASE @ EXTRACT HOLD ;;
:: #S ( u -- 0 ) BEGIN # DUP WHILE REPEAT ;;
CRR
:: SIGN ( n -- ) 0< IF ( CHAR - ) 2D LIT HOLD THEN ;;
:: #> ( w -- b u ) DROP HLD @ PAD OVER - ;;
:: str ( n -- b u ) DUP >R ABS <# #S R> SIGN #> ;;
:: HEX ( -- ) 10 LIT BASE ! ;;
:: DECIMAL ( -- ) 0A LIT BASE ! ;;

CRR .( Numeric Input ) CRR \ single precision

:: DIGIT? ( c base -- u t )
  >R ( CHAR 0 ) 30 LIT - 9 LIT OVER <
  IF 7 LIT - DUP 0A LIT  < OR THEN DUP R> U< ;;
:: NUMBER? ( a -- n T | a F )
  BASE @ >R  0 LIT OVER COUNT ( a 0 b n)
  OVER C@ ( CHAR $ ) 24 LIT =
  IF HEX SWAP 1+ SWAP 1- THEN ( a 0 b' n')
  OVER C@ ( CHAR - ) 2D LIT = >R ( a 0 b n)
  SWAP R@ - SWAP R@ + ( a 0 b" n") ?DUP
  IF 1- ( a 0 b n)
    FOR DUP >R C@ BASE @ DIGIT?
      WHILE SWAP BASE @ * +  R> 1+
    NEXT DROP R@ ( b ?sign) IF NEGATE THEN SWAP
      ELSE R> R> ( b index) 2DROP ( digit number) 2DROP 0 LIT
      THEN DUP
  THEN R> ( n ?sign) 2DROP R> BASE ! ;;

CRR .( Basic I/O ) CRR

:: ?KEY ( -- c T | F ) KEY -1 LIT ;;
:: SPACE ( -- ) BL EMIT ;;
CRR
:: CHARS ( +n c -- ) \ ???ANS conflict
  SWAP 0 LIT MAX FOR AFT DUP EMIT THEN NEXT DROP ;;
:: SPACES ( +n -- ) BL CHARS ;;
:: TYPE ( b u -- ) FOR AFT DUP C@ EMIT 1+ THEN NEXT DROP ;;
:: CR ( -- ) ( =Cr ) 0D LIT EMIT ( =Lf ) 0A LIT EMIT ;;
:: do$ ( -- a )
  R> R@ R> COUNT + >R SWAP >R ;; COMPILE-ONLY
CRR
:: $"| ( -- a ) do$ ;; COMPILE-ONLY
:: ."| ( -- ) do$ COUNT TYPE ;; COMPILE-ONLY
::  .R ( n +n -- ) >R str      R> OVER - SPACES TYPE ;;
:: U.R ( u +n -- ) >R <# #S #> R> OVER - SPACES TYPE ;;
:: U. ( u -- ) <# #S #> SPACE TYPE ;;
::  . ( n -- ) BASE @ 0A LIT  XOR IF U. EXIT THEN str SPACE TYPE ;;
:: ? ( a -- ) @ . ;;

CRR .( Parsing ) CRR

:: (parse) ( b u c -- b u delta ; <string> )
  tmp !  OVER >R  DUP \ b u u
  IF 1-  tmp @ BL =
    IF \ b u' \ 'skip'
      FOR BL OVER C@ - 0< NOT  WHILE 1+
      NEXT ( b) R> DROP 0 LIT DUP EXIT \ all delim
        THEN  R>
    THEN OVER SWAP \ b' b' u' \ 'scan'
    FOR tmp @ OVER C@ -  tmp @ BL =
      IF 0< THEN WHILE 1+
    NEXT DUP >R  ELSE R> DROP DUP 1+ >R
                 THEN OVER -  R>  R> - EXIT
  THEN ( b u) OVER R> - ;;
:: PARSE ( c -- b u ; <string> )
  >R  TIB >IN @ +  #TIB @ >IN @ -  R> (parse) >IN +! ;;
:: CHAR ( -- c ) BL PARSE DROP C@ ;;
:: TOKEN ( -- a ;; <string> )
  BL PARSE 1F LIT MIN HERE 1+ PACK$ ;;
:: WORD ( c -- a ; <string> ) PARSE HERE 1+ PACK$ ;;

CRR .( Dictionary Search ) CRR

:: NAME> ( a -- xt ) COUNT 1F LIT AND + ;;
:: SAME? ( a a u -- a a f \ -0+ )
  FOR AFT OVER R@ + @
          OVER R@ + @ -  ?DUP
    IF R> DROP EXIT THEN THEN
  NEXT 0 LIT ;;
:: find ( a va -- xt na | a F ) \ ************ be careful here!!!
  SWAP              \ va a
  DUP C@ tmp !  \ va a  \ get cell count                      !!!
  DUP @ >R          \ va a  \ count
  1+ SWAP        \ a' va
  BEGIN @ DUP       \ a' na na
    IF DUP @ 3F LIT AND  R@ XOR \ ignore lexicon bits
      IF 1+ -1 LIT ELSE 1+ tmp @ SAME? THEN
    ELSE R> DROP SWAP 1- SWAP EXIT \ a F
    THEN
  WHILE 1- 1- \ a' la
  REPEAT R> DROP SWAP DROP 1-  DUP NAME> SWAP ;;
:: NAME? ( a -- xt na | a F )
  CONTEXT  DUP 2@ XOR IF 1- THEN >R \ context<>also
  BEGIN R>  1+  DUP >R  @  ?DUP
  WHILE find  ?DUP
  UNTIL R> DROP EXIT THEN R> DROP  0 LIT ;;

CRR .( Terminal ) CRR

:: ^H ( b b b -- b b b ) \ backspace
  >R OVER R> SWAP OVER XOR
  IF ( =BkSp ) 8 LIT 'ECHO @EXECUTE
     1-         BL 'ECHO @EXECUTE \ distructive
     ( =BkSp ) 8 LIT 'ECHO @EXECUTE \ backspace
  THEN ;;
:: TAP ( bot eot cur c -- bot eot cur )
  DUP 'ECHO @EXECUTE OVER C! 1+ ;;
:: kTAP ( bot eot cur c -- bot eot cur )
  DUP ( =Cr ) 0D LIT XOR
  IF ( =BkSp ) 8 LIT XOR IF BL TAP ELSE ^H THEN EXIT
  THEN DROP SWAP DROP DUP ;;
CRR
:: accept ( b u -- b u )
  OVER + OVER
  BEGIN 2DUP XOR
  WHILE  KEY  DUP BL -  5F LIT U<
    IF TAP ELSE 'TAP @EXECUTE THEN
  REPEAT DROP  OVER - ;;
:: EXPECT ( b u -- ) accept SPAN ! DROP ;;
:: QUERY ( -- )
  TIB 50 LIT accept #TIB !  DROP 0 LIT >IN ! ;;

CRR .( Error handling ) CRR

:: ABORT ( -- ) NULL$ @EXECUTE ;;
:: abort" ( f -- ) IF do$ COUNT TYPE ABORT THEN do$ DROP ;; COMPILE-ONLY

CRR .( Interpret ) CRR

:: $INTERPRET ( a -- )
  NAME?  ?DUP
  IF @ 40 LIT AND
    ABORT" $LIT compile only" EXECUTE EXIT
  THEN NUMBER? IF EXIT THEN 
  SPACE COUNT TYPE 3F LIT EMIT ABORT ;;

808 ORG

:: [ ( -- ) DOLIT $INTERPRET 'EVAL ! ;; IMMEDIATE
:: .OK ( -- ) DOLIT $INTERPRET 'EVAL @ = IF SPACE ."| $LIT OK" THEN CR ;;
:: EVAL ( -- )
  BEGIN TOKEN DUP C@
  WHILE 'EVAL @EXECUTE \ ?STACK
  REPEAT DROP 'PROMPT @EXECUTE ;;

CRR .( Shell ) CRR

:: PRESET ( -- ) ( =TIB) endRAM 50 forth- LIT #TIB 1+ ! ;;
:: QUIT ( -- )
   PRESET
   [ BEGIN QUERY EVAL AGAIN ;;

CRR .( Compiler Primitives ) CRR

:: ' ( -- xt ) TOKEN NAME? IF EXIT THEN ."| $LIT ?" ABORT ;;
:: ALLOT ( n -- ) CP +! ;;
:: , ( w -- ) HERE DUP 1+ CP ! ! ;; \ ???ALIGNED
:: [COMPILE] ( -- ; <string> ) ' , ;; IMMEDIATE
CRR
:: COMPILE ( -- ) R> DUP @ , 1+ >R ;; COMPILE-ONLY
:: LITERAL doLIT doLIT , , ;; IMMEDIATE
:: $," ( -- ) ( CHAR " ) 22 LIT WORD C@ 1+ 1+ ALLOT ;;
:: RECURSE ( -- ) LAST @ NAME> , ;; IMMEDIATE

CRR .( Name Compiler ) CRR

:: ?UNIQUE ( a -- a )
  DUP NAME? IF SPACE ."| $LIT reDef " OVER COUNT TYPE THEN DROP ;;
:: $,n ( a -- )
  DUP C@
  IF ?UNIQUE
    ( na) DUP COUNT + CP !
    ( na) DUP LAST ! \ for OVERT
    ( na) 1-
    ( la) CURRENT @ @ SWAP ! EXIT
  THEN ."| $LIT ???" ABORT ;;

CRR .( FORTH Compiler ) CRR

:: $COMPILE ( a -- )
  NAME? ?DUP
  IF @ 80 LIT AND
    IF EXECUTE ELSE , THEN EXIT
  THEN NUMBER?
  IF LITERAL EXIT
  THEN ."| $LIT ?" ABORT ;;
:: OVERT ( -- ) LAST @ CURRENT @ ! ;;
:: ; ( -- )
  COMPILE EXIT [ OVERT ;; COMPILE-ONLY IMMEDIATE
:: ] ( -- ) DOLIT $COMPILE   'EVAL ! ;;
:: : ( -- ; <string> ) TOKEN $,n ( ' doLIST ) 2002 LIT , ] ;;

CRR .( Defining Words ) CRR

:: code ( -- ; <string> ) TOKEN $,n OVERT ;;
:: VARIABLE ( n -- ; <string> )
  code ( DOVAR ) 2005 LIT , ;;

CRR .( Tools ) CRR

:: _TYPE ( b u -- )
  FOR AFT DUP C@ >CHAR EMIT 1+ THEN NEXT DROP ;;
:: dm+ ( b u -- b )
  OVER 5 LIT U.R SPACE FOR AFT DUP C@ 6 LIT U.R 1+ THEN NEXT ;;
:: DUMP ( b u -- )
   8 LIT /
  FOR AFT CR 8 LIT 2DUP dm+ ROT ROT
     2 LIT SPACES _TYPE
  THEN NEXT  DROP  ;;

CRR

:: >NAME ( xt -- na | F )
  CURRENT
  BEGIN 1+ @ ?DUP WHILE 2DUP
    BEGIN @ DUP WHILE 2DUP NAME> XOR
    WHILE 1-
    REPEAT      THEN SWAP DROP ?DUP
  UNTIL SWAP DROP SWAP DROP EXIT THEN DROP 0 LIT ;;
:: .ID ( a -- )
  ?DUP IF COUNT $01F LIT AND _TYPE EXIT THEN SPACE ."| $LIT {noName}" ;;
:: SEE ( -- ; <string> )
  ' CR
  BEGIN
    20 LIT FOR
      1+ DUP @ DUP IF >NAME THEN ?DUP
      IF SPACE .ID ELSE DUP @ U. THEN
    NEXT KEY 0D LIT =                  \ can't use ESC on terminal
  UNTIL DROP ;;
:: WORDS ( -- )
  CR  CONTEXT @
  BEGIN @ ?DUP
  WHILE DUP SPACE .ID 1-
  REPEAT ;;

include diagnose.txt

CRR .( Hardware reset ) CRR

:: VER ( -- u ) 101 LIT ;;
:: hi ( -- )
\   !IO
   HEX           \   !IO \ initialize IO device & sign on
   CR ."| $LIT P16 eForth v"
   VER <# # # ( CHAR . ) 2E LIT HOLD # #> TYPE
   CR DECIMAL
   ;; COMPILE-ONLY
:: EMPTY ( -- )
   C44 LIT CP !             \ init code dictionary pointer
   C2F LIT DUP LAST !       \ init last name field pointer
   VOCAB !
   FORTH CONTEXT @ DUP CURRENT 2! \ init vocabulary
   ;;
CREATE 'BOOT  hi  \ application vector
:: START ( -- )
    DOLIT EMIT 'ECHO !
    DOLIT kTap 'TAP !
    DOLIT .OK 'PROMPT !
    QUIT
    ;;
:: COLD ( -- )
    diagnose
\    BEGIN KEY EMIT DOLIT 42 #, EMIT AGAIN  \ for RS232 tests
    'BOOT @EXECUTE
    EMPTY
    DOLIT START NULL$ !
    DOLIT NUMBER? 'NUMBER !
    DOLIT $INTERPRET 'EVAL !
    START
    ;;

CRR .( Structures ) CRR

:: <MARK ( -- a ) HERE ;;
:: <RESOLVE ( a -- ) , ;;
:: >MARK ( -- A ) HERE 0 LIT , ;;
:: >RESOLVE ( A -- ) <MARK SWAP ! ;;
CRR
:: FOR ( -- a ) COMPILE >R <MARK ;; IMMEDIATE
:: BEGIN ( -- a ) <MARK ;; IMMEDIATE
:: NEXT ( a -- ) COMPILE doNEXT <RESOLVE ;; IMMEDIATE
:: UNTIL ( a -- ) COMPILE qbranch <RESOLVE ;; IMMEDIATE
CRR
:: AGAIN ( a -- ) COMPILE  branch <RESOLVE ;; IMMEDIATE
:: IF ( -- A )   COMPILE qbranch >MARK ;; IMMEDIATE
:: AHEAD ( -- A ) COMPILE branch >MARK ;; IMMEDIATE
:: REPEAT ( A a -- ) AGAIN >RESOLVE ;; IMMEDIATE
CRR
:: THEN ( A -- ) >RESOLVE ;; IMMEDIATE
:: AFT ( a -- a A ) DROP AHEAD BEGIN SWAP ;; IMMEDIATE
:: ELSE ( A -- A )  AHEAD SWAP THEN ;; IMMEDIATE
:: WHEN ( a A -- a A a ) IF OVER ;; IMMEDIATE
:: WHILE ( a -- A a )    IF SWAP ;; IMMEDIATE

CRR .( compilers ) CRR

:: ABORT" ( -- ; <string> ) COMPILE abort" $," ;; IMMEDIATE
:: $" ( -- ; <string> ) DOLIT $"| HERE ! $," ;; IMMEDIATE
:: ." ( -- ; <string> ) DOLIT ."| HERE ! $," ;; IMMEDIATE
:: CREATE ( -- ; <string> )
  code 2005 LIT , ;;
:: VARIABLE ( -- ; <string> ) CREATE 0 LIT , ;;
CRR
:: .( ( -- ) 29 LIT PARSE TYPE ;; IMMEDIATE
:: \ ( -- ) #TIB @ >IN ! ;; IMMEDIATE
:: ( 29 LIT PARSE 2DROP ;; IMMEDIATE
:: IMMEDIATE 80 LIT LAST @ @ OR LAST @ ! ;;

CRR



